<?php
// $Id: advanced_menu_core.admin.inc $

/**
 * @file
 * Administrative page callbaks for advanced_menu_core module.
 */

/**
 * Menu callback which shows an overview page of all the custom menus and their descriptions.
 */
function advanced_menu_core_overview_page() {
  global $user;
  $header = array(t('Title'), array('data' => t('Operations'), 'colspan' => '3'));
  $rows = array();
  // User #1 has all privileges as does the 'administer menu' permission
  if ($user->uid == 1 || user_access('administer menu')) {
    $result = db_select('menu_custom')->fields('menu_custom')->orderBy('title', 'ASC')->execute();
  }
  else {
    if (module_exists('advanced_menu_menu_admin')) {
      //Build the SELECT conditions based on the current user roles
      $role_ids = array();
      foreach ($user->roles as $key => $value) {
        $role_ids[] = $key;
      }
      $menu_select = db_select('menu_custom','c')->fields('c')->condition('r.rid', $role_ids, 'IN')->orderBy('c.title', 'ASC');
      $menu_select->join('advanced_menu_menu_admin_roles','r','r.menu_name = c.menu_name');
      $result = $menu_select->execute();
    }
  }
  foreach ($result as $menu) {
    $row = array(theme('menu_admin_overview', array('title' => $menu->title, 'name' => $menu->menu_name, 'description' => $menu->description)));
    $row[] = array('data' => l(t('list links'), 'admin/structure/menu/manage/' . $menu->menu_name));
    $row[] = array('data' => l(t('edit menu'), 'admin/structure/menu/manage/' . $menu->menu_name . '/edit'));
    $row[] = array('data' => l(t('add link'), 'admin/structure/menu/manage/' . $menu->menu_name . '/add'));
    $rows[] = $row;
  }
  return theme('table', array('header' => $header, 'rows' => $rows));
}

